// Copyright 2000 Kim Neunert (k9ert@gmx.de), this is free Software (GNU Public License)
package struktor.gui;
import struktor.*;
import struktor.strukelements.*;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

/** Abstrakte Klasse fr den Struktogramm-Auswhler. 
 * Wird einmal fr das Applet (simple JComboBox) und einmal fr 
 * Application implementiert (Meneintrag in der Menubar)
 * Die ganze Geschichte knnte evtl. auch mit Interfaces gelst werden
 */
abstract class StrukSelector extends JComponent
implements ItemListener
{
	/** Aktualisiert den View */
	public abstract void newStruktogrammCreated(String name);
	
	/** Aktualisiert den View */
	public abstract void struktogrammDeleted(String name);
	
	/** Aktualisiert den View */
	public abstract void struktogrammRenamed(String oldName, String newName);
	
	/** Aktualisiert den View */
	public abstract void struktogrammSelected(String name);
	
	/** Nur fr StrukSelectorAppEvt (.add(...) geht nicht)*/
	public abstract void addYourselfTo(JMenuBar menuBar);
	
	/** Nur fr StrukSelectorEvt (.add(...) geht nicht)*/
	public abstract void addYourselfTo(Box box);
}