// Copyright 2000 Kim Neunert (k9ert@gmx.de), this is free Software (GNU Public License)
package struktor.gui;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

/** Abstrakte Klasse fr den View-Auswhler. 
 * Wird einmal fr das Applet (simple JComboBox) und einmal fr 
 * Application implementiert (Meneintrag in der Menubar)
 * Die ganze Geschichte knnte evtl. auch mit Interfaces gelst werden
 */
abstract class ViewSelector extends JComponent
implements ItemListener
{
	/** Aktualisiert den View */
	public abstract void viewChanged(int change);
	
	/** Nur fr ViewSelectorAppEvt (.add(...) geht nicht)*/
	public abstract void addYourselfTo(JMenuBar menuBar);
	
	/** Nur fr ViewSelectorEvt (.add(...) geht nicht)*/
	public abstract void addYourselfTo(Box box);
}